lz_encoder_hash.h File Reference

Hash macros for match finders. More...

`#include "check.h"`

## Macros

#define | hash_table lzma_crc32_table[0]
#define | HASH_2_SIZE (UINT32_C(1) << 10)
#define | HASH_3_SIZE (UINT32_C(1) << 16)
#define | HASH_4_SIZE (UINT32_C(1) << 20)
#define | HASH_2_MASK (HASH_2_SIZE - 1)
#define | HASH_3_MASK (HASH_3_SIZE - 1)
#define | HASH_4_MASK (HASH_4_SIZE - 1)
#define | FIX_3_HASH_SIZE (HASH_2_SIZE)
#define | FIX_4_HASH_SIZE (HASH_2_SIZE + HASH_3_SIZE)
#define | FIX_5_HASH_SIZE (HASH_2_SIZE + HASH_3_SIZE + HASH_4_SIZE)
#define | hash_2_calc()
#define | hash_3_calc()
#define | hash_4_calc()
#define | hash_5_calc()
#define | hash_zip_calc()
#define | mt_hash_2_calc()
#define | mt_hash_3_calc()
#define | mt_hash_4_calc()

## Detailed Description

Hash macros for match finders.

## Macro Definition Documentation

## hash_2_calc

#define hash_2_calc | ( |  | ) |

Value:
const uint32_t hash_value \
= (uint32_t)(cur[0]) | ((uint32_t)(cur[1]) << 8)

## hash_3_calc

#define hash_3_calc | ( |  | ) |

Value:
const uint32_t temp = hash_table[cur[0]] ^ cur[1]; \
const uint32_t hash_2_value = temp & HASH_2_MASK; \
const uint32_t hash_value \
= (temp ^ ((uint32_t)(cur[2]) << 8)) & mf->hash_mask

## hash_4_calc

#define hash_4_calc | ( |  | ) |

Value:
const uint32_t temp = hash_table[cur[0]] ^ cur[1]; \
const uint32_t hash_2_value = temp & HASH_2_MASK; \
const uint32_t hash_3_value \
= (temp ^ ((uint32_t)(cur[2]) << 8)) & HASH_3_MASK; \
const uint32_t hash_value = (temp ^ ((uint32_t)(cur[2]) << 8) \
^ (hash_table[cur[3]] << 5)) & mf->hash_mask

## hash_5_calc

#define hash_5_calc | ( |  | ) |

Value:
const uint32_t temp = hash_table[cur[0]] ^ cur[1]; \
const uint32_t hash_2_value = temp & HASH_2_MASK; \
const uint32_t hash_3_value \
= (temp ^ ((uint32_t)(cur[2]) << 8)) & HASH_3_MASK; \
uint32_t hash_4_value = (temp ^ ((uint32_t)(cur[2]) << 8) ^ \
^ hash_table[cur[3]] << 5); \
const uint32_t hash_value \
= (hash_4_value ^ (hash_table[cur[4]] << 3)) \
& mf->hash_mask; \
hash_4_value &= HASH_4_MASK

## hash_zip_calc

#define hash_zip_calc | ( |  | ) |

Value:
const uint32_t hash_value \
= (((uint32_t)(cur[2]) | ((uint32_t)(cur[0]) << 8)) \
^ hash_table[cur[1]]) & 0xFFFF

## mt_hash_2_calc

#define mt_hash_2_calc | ( |  | ) |

Value:
const uint32_t hash_2_value \
= (hash_table[cur[0]] ^ cur[1]) & HASH_2_MASK

## mt_hash_3_calc

#define mt_hash_3_calc | ( |  | ) |

Value:
const uint32_t temp = hash_table[cur[0]] ^ cur[1]; \
const uint32_t hash_2_value = temp & HASH_2_MASK; \
const uint32_t hash_3_value \
= (temp ^ ((uint32_t)(cur[2]) << 8)) & HASH_3_MASK

## mt_hash_4_calc

#define mt_hash_4_calc | ( |  | ) |

Value:
const uint32_t temp = hash_table[cur[0]] ^ cur[1]; \
const uint32_t hash_2_value = temp & HASH_2_MASK; \
const uint32_t hash_3_value \
= (temp ^ ((uint32_t)(cur[2]) << 8)) & HASH_3_MASK; \
const uint32_t hash_4_value = (temp ^ ((uint32_t)(cur[2]) << 8) ^ \
(hash_table[cur[3]] << 5)) & HASH_4_MASK